package weaver.docs.webservices;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Writer;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;
import oracle.sql.CLOB;
import org.apache.axis.encoding.Base64;
import weaver.conn.ConnStatement;
import weaver.conn.RecordSet;
import weaver.crm.Maint.CustomerInfoComInfo;
import weaver.docs.DocDetailLog;
import weaver.docs.category.DocTreeDocFieldComInfo;
import weaver.docs.category.MainCategoryComInfo;
import weaver.docs.category.SecCategoryComInfo;
import weaver.docs.category.SubCategoryComInfo;
import weaver.docs.docs.CustomFieldManager;
import weaver.docs.docs.DocCoder;
import weaver.docs.docs.DocComInfo;
import weaver.docs.docs.DocImageManager;
import weaver.docs.docs.DocManager;
import weaver.docs.docs.DocViewer;
import weaver.docs.docs.ImageFileIdUpdate;
import weaver.file.AESCoder;
import weaver.file.FileManage;
import weaver.file.FileUpload;
import weaver.file.ImageFileManager;
import weaver.file.ImageInfo;
import weaver.file.Prop;
import weaver.file.multipart.DefaultFileRenamePolicy;
import weaver.general.BaseBean;
import weaver.general.GCONST;
import weaver.general.MD5;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.resource.ResourceComInfo;
import weaver.ldap.LdapUtil;
import weaver.share.ShareManager;
import weaver.splitepage.operate.SpopForDoc;
import weaver.system.SystemComInfo;
import weaver.systeminfo.SystemEnv;
import weaver.systeminfo.language.LanguageComInfo;
import weaver.workflow.field.BrowserComInfo;
import weaver.workflow.request.ResourceConditionManager;

public class DocServiceImpl extends BaseBean implements DocService {
   private static ImageFileIdUpdate imageFileIdUpdate = new ImageFileIdUpdate();
   private static final Map sessionIDMap = new HashMap();
   private static final Map sessionTimeMap = new HashMap();

   private static synchronized void putSessionId(String var0, Object var1) {
      Iterator var2 = sessionTimeMap.keySet().iterator();

      while(var2.hasNext()) {
         String var3 = (String)var2.next();
         Date var4 = (Date)sessionTimeMap.get(var3);
         if (var4.getTime() - (new Date()).getTime() > 1800000L) {
            sessionTimeMap.remove(var3);
            sessionIDMap.remove(var3);
         }
      }

      sessionIDMap.put(var0, var1);
      sessionTimeMap.put(var0, new Date());
   }

   private static synchronized Object gutSessionId(String var0) {
      Iterator var1 = sessionTimeMap.keySet().iterator();

      while(var1.hasNext()) {
         String var2 = (String)var1.next();
         Date var3 = (Date)sessionTimeMap.get(var2);
         if (var3.getTime() - (new Date()).getTime() > 1800000L) {
            sessionTimeMap.remove(var2);
            sessionIDMap.remove(var2);
         }
      }

      sessionTimeMap.put(var0, new Date());
      return sessionIDMap.get(var0);
   }

   public String login(String var1, String var2, int var3, String var4) throws Exception {
      String var5 = "";
      if (var1 != null && !"".equals(var1) && var2 != null && !"".equals(var2) && var4 != null && !"".equals(var4)) {
         int var6 = this.checkLogin(var1, var2, var3);
         this.writeLog("checkLogin: logresult = " + var6);
         if (var6 == 1) {
            int var7 = this.getUserId(var1, var3);
            this.writeLog("login: userid = " + var7);
            User var8 = this.getUserById(var7);
            if (var8 != null) {
               var8.setLoginip(var4);
               String var9 = Util.getRandom() + "|" + var4;
               var5 = (new MD5()).getMD5ofStr(var9);
               putSessionId(var5, var8);
            }
         }
      }

      return var5;
   }

   public int createDoc(DocInfo var1, String var2) throws Exception {
      User var3 = (User)gutSessionId(var2);
      return this.createDocByUser(var1, var3);
   }

   public int createDocByUser(DocInfo var1, User var2) throws Exception {
      if (var2 != null && var1 != null) {
         String var3 = "";

         try {
            SecCategoryComInfo var4 = new SecCategoryComInfo();
            DocComInfo var5 = new DocComInfo();
            DocManager var6 = new DocManager();
            DocViewer var7 = new DocViewer();
            DocImageManager var8 = new DocImageManager();
            RecordSet var9 = new RecordSet();
            int var10 = var6.getNextDocId(var9);
            var1.setId(var10);
            DocAttachment[] var11 = var1.getAttachments();

            for(int var12 = 0; var11 != null && var12 < var11.length; ++var12) {
               DocAttachment var13 = var11[var12];
               if (var13 != null && (var13.getFilecontent() != null && !"".equals(var13.getFilecontent()) || var13.getFilerealpath() != null && !"".equals(var13.getFilerealpath()))) {
                  var13 = this.saveAttachment(var13);
                  if (var13 == null || var13.getImagefileid() <= 0) {
                     this.writeLog("Save Attachment Error!");
                     continue;
                  }

                  var13.setDocid(var10);
                  int var14 = var13.getImagefileid();
                  var3 = var13.getFilename();
                  String var15 = "";
                  var8.resetParameter();
                  if ("".equals(var1.getDocSubject())) {
                     var1.setDocSubject(this.getFileMainName(var3));
                     var8.setImagefilename(var3);
                     var15 = this.getFileExt(var3);
                  } else {
                     var8.setImagefilename(var3);
                     var15 = this.getFileExt(var3);
                  }

                  if (var15.equalsIgnoreCase("doc")) {
                     var8.setDocfiletype("3");
                  } else if (var15.equalsIgnoreCase("xls")) {
                     var8.setDocfiletype("4");
                  } else if (var15.equalsIgnoreCase("ppt")) {
                     var8.setDocfiletype("5");
                  } else if (var15.equalsIgnoreCase("wps")) {
                     var8.setDocfiletype("6");
                  } else if (var15.equalsIgnoreCase("docx")) {
                     var8.setDocfiletype("7");
                  } else if (var15.equalsIgnoreCase("xlsx")) {
                     var8.setDocfiletype("8");
                  } else if (var15.equalsIgnoreCase("pptx")) {
                     var8.setDocfiletype("9");
                  } else {
                     var8.setDocfiletype("2");
                  }

                  var8.setDocid(var10);
                  var8.setImagefileid(var14);
                  var8.setIsextfile("1");
                  var8.AddDocImageInfo();
               }

               var11[var12] = var13;
            }

            var1.setAttachments(var11);
            String var17 = "";
            String var18 = "";
            var17 = TimeUtil.getCurrentDateString();
            var18 = TimeUtil.getOnlyCurrentTimeString();
            var6.setId(var10);
            var6.setMaincategory(var1.getMaincategory());
            var6.setSubcategory(var1.getSubcategory());
            var6.setSeccategory(var1.getSeccategory());
            var6.setLanguageid(var2.getLanguage());
            var6.setDoccontent(var1.getDoccontent());
            var6.setDocstatus("1");
            var6.setDocsubject(var1.getDocSubject());
            var6.setDoccreaterid(var2.getUID());
            var6.setDocCreaterType(var2.getLogintype());
            var6.setUsertype(var2.getLogintype());
            var6.setOwnerid(var2.getUID());
            var6.setOwnerType(var2.getLogintype());
            var6.setDoclastmoduserid(var2.getUID());
            var6.setDocLastModUserType(var2.getLogintype());
            var6.setDoccreatedate(var17);
            var6.setDoclastmoddate(var17);
            var6.setDoccreatetime(var18);
            var6.setDoclastmodtime(var18);
            var6.setDoclangurage(var2.getLanguage());
            var6.setKeyword(var1.getKeyword());
            var6.setIsapprover("0");
            var6.setIsreply(var1.getIsreply());
            var6.setReplydocid(var1.getReplydocid());
            var6.setDocdepartmentid(var2.getUserDepartment());
            var6.setDocreplyable("1");
            var6.setAccessorycount(1);
            if (var1.getParentids() != null && !var1.getParentids().trim().equals("")) {
               var6.setParentids(var1.getParentids() + "," + var10);
            } else {
               var6.setParentids("" + var10);
            }

            var6.setOrderable("" + var4.getSecOrderable(var1.getSeccategory()));
            var6.setClientAddress(var2.getLoginip());
            var6.setUserid(var2.getUID());
            String var19 = var1.getDocCode();
            if (var19 != null && !var19.trim().equals("")) {
               var6.setDocCode(var19);
            } else {
               DocCoder var20 = new DocCoder();
               var6.setDocCode(var20.getDocCoder("" + var1.getSeccategory()));
            }

            var6.setDocEditionId(var6.getNextEditionId(var9));
            var6.setDocEdition(1);
            var6.AddDocInfo();
            var6.AddShareInfo();
            var5.addDocInfoCache("" + var10);
            var7.setDocShareByDoc("" + var10);
            var9.executeSql(" update docdetail set accessorycount = (select count(distinct id) from DocImageFile where isextfile = '1' and docid = " + var10 + " and docfiletype <> '1'   and docfiletype <> '11') where id = " + var10);
            return var10;
         } catch (Exception var16) {
            this.writeLog("Save Document error:", var16);
            return -1;
         }
      } else {
         return 0;
      }
   }

   public int updateDoc(DocInfo var1, String var2) throws Exception {
      User var3 = (User)gutSessionId(var2);
      return this.updateDocByUser(var1, var3);
   }

   public int updateDocByUser(DocInfo var1, User var2) throws Exception {
      if (!this.getRight(var1, var2, 0)) {
         return var1.getId();
      } else {
         DocInfo var3 = this.getDocByUser(var1.getId(), var2, "");
         if (var2 != null && var3 != null && var1 != null) {
            SecCategoryComInfo var4 = new SecCategoryComInfo();
            DocManager var5 = new DocManager();
            DocComInfo var6 = new DocComInfo();
            RecordSet var7 = new RecordSet();
            int var8 = var3.getId();
            int var9;
            boolean var10;
            int var11;
            DocImageManager var12;
            int var17;
            if (var4.isEditionOpen(var1.getSeccategory()) && var3.getDocStatus() != 0 && var3.getDocStatus() != 4) {
               var8 = var5.getNextDocId(var7);
               var1.setId(var8);
               if (var3.getDocEditionId() <= 0) {
                  var1.setDocEditionId(var5.getNextEditionId(var7));
                  var1.setDocEdition(1);
                  var7.executeSql("update DocDetail set docEditionId=" + var1.getDocEditionId() + ",docEdition=" + var1.getDocEdition() + " where id=" + var3.getId());
                  var7.executeSql("update docdetail set docstatus = 7,ishistory = 1 where id <> " + var1.getId() + " and docedition > 0 and docedition <= " + var1.getDocEdition() + " and doceditionid > 0 and doceditionid = " + var1.getDocEditionId());
               } else if (var3.getDocEdition() <= 0) {
                  var1.setDocEdition(var6.getEdition(var1.getDocEditionId()) + 1);
                  var7.executeSql("update DocDetail set docEditionId=" + var1.getDocEditionId() + ",docEdition=" + var1.getDocEdition() + " where id=" + var3.getId());
                  var7.executeSql("update docdetail set docstatus = 7,ishistory = 1 where id <> " + var1.getId() + " and docedition > 0 and docedition <= " + var1.getDocEdition() + " and doceditionid > 0 and doceditionid = " + var1.getDocEditionId());
               } else if (var3.getDocEditionId() > 0 && var3.getDocEdition() > 0) {
                  var7.executeSql("update docdetail set docstatus = 7,ishistory = 1 where id <> " + var1.getId() + " and docedition > 0 and docedition <= " + var1.getDocEdition() + " and doceditionid > 0 and doceditionid = " + var1.getDocEditionId());
               }

               var5.setId(var1.getId());
               var5.setDocsubject(var1.getDocSubject());
               var5.setMaincategory(var1.getMaincategory());
               var5.setSubcategory(var1.getSubcategory());
               var5.setSeccategory(var1.getSeccategory());
               var5.setUsertype(var2.getLogintype());
               var5.setClientAddress(var2.getLoginip());
               var5.setDoccreaterid(var1.getDoccreaterid());
               var5.setDocCreaterType(var1.getDoccreatertype() + "");
               String var16 = "";

               for(var17 = 0; var17 < var3.getAttachments().length; ++var17) {
                  boolean var19 = false;

                  for(int var20 = 0; var20 < var1.getAttachments().length; ++var20) {
                     if (var1.getAttachments()[var20].getImagefileid() == var3.getAttachments()[var17].getImagefileid()) {
                        var19 = true;
                     }
                  }

                  if (!var19) {
                     var16 = var16 + "," + var3.getAttachments()[var17].getImagefileid();
                  }
               }

               if (var16.startsWith(",")) {
                  var16 = var16.substring(1);
               }

               if (var16.endsWith(",")) {
                  var16 = var16.substring(0, var16.length() - 1);
               }

               var5.addNewDocForEdition(var3.getId(), var16);
            } else {
               for(var9 = 0; var9 < var3.getAttachments().length; ++var9) {
                  var10 = false;

                  for(var11 = 0; var11 < var1.getAttachments().length; ++var11) {
                     if (var1.getAttachments()[var11].getImagefileid() == var3.getAttachments()[var9].getImagefileid()) {
                        var10 = true;
                     }
                  }

                  if (!var10) {
                     DocAttachment var18 = var3.getAttachments()[var9];
                     var12 = new DocImageManager();
                     var12.setDocid(var18.getDocid());
                     var12.setImagefileid(var18.getImagefileid());
                     var12.DeleteSingleDocImageInfo();
                  }
               }
            }

            String var15;
            String var22;
            for(var9 = 0; var9 < var1.getAttachments().length; ++var9) {
               var10 = false;

               for(var11 = 0; var11 < var3.getAttachments().length; ++var11) {
                  if (var1.getAttachments()[var9].getImagefileid() == var3.getAttachments()[var11].getImagefileid()) {
                     var10 = true;
                  }
               }

               if (!var10) {
                  var22 = "";
                  var12 = new DocImageManager();
                  DocAttachment var13 = var1.getAttachments()[var9];
                  if (var13 != null && (var13.getFilecontent() != null && !"".equals(var13.getFilecontent()) || var13.getFilerealpath() != null && !"".equals(var13.getFilerealpath()))) {
                     var13 = this.saveAttachment(var13);
                     if (var13 == null || var13.getImagefileid() <= 0) {
                        this.writeLog("Save Attachment Error!");
                        continue;
                     }

                     var13.setDocid(var8);
                     int var14 = var13.getImagefileid();
                     var22 = var13.getFilename();
                     var15 = "";
                     var12.resetParameter();
                     if ("".equals(var1.getDocSubject())) {
                        var1.setDocSubject(this.getFileMainName(var22));
                        var12.setImagefilename(var22);
                        var15 = this.getFileExt(var22);
                     } else {
                        var12.setImagefilename(var22);
                        var15 = this.getFileExt(var22);
                     }

                     if (var15.equalsIgnoreCase("doc")) {
                        var12.setDocfiletype("3");
                     } else if (var15.equalsIgnoreCase("xls")) {
                        var12.setDocfiletype("4");
                     } else if (var15.equalsIgnoreCase("ppt")) {
                        var12.setDocfiletype("5");
                     } else if (var15.equalsIgnoreCase("wps")) {
                        var12.setDocfiletype("6");
                     } else if (var15.equalsIgnoreCase("docx")) {
                        var12.setDocfiletype("7");
                     } else if (var15.equalsIgnoreCase("xlsx")) {
                        var12.setDocfiletype("8");
                     } else if (var15.equalsIgnoreCase("pptx")) {
                        var12.setDocfiletype("9");
                     } else {
                        var12.setDocfiletype("2");
                     }

                     var12.setDocid(var8);
                     var12.setImagefileid(var14);
                     var12.setIsextfile("1");
                     var12.AddDocImageInfo();
                  }

                  var1.getAttachments()[var9] = var13;
               }
            }

            this.updateDocInfo(var1, var2);
            var7.executeSql(" update docdetail set accessorycount = (select count(distinct id) from DocImageFile where isextfile = '1' and docid = " + var8 + " and docfiletype <> '1'   and docfiletype <> '11') where id = " + var8);
            RecordSet var21 = new RecordSet();
            var21.executeSql("delete DocDummyDetail where docid=" + var1.getId());
            if (var1.getDummyIds() != null) {
               for(var17 = 0; var17 < var1.getDummyIds().length; ++var17) {
                  var22 = var1.getDummyIds()[var17] + "";
                  if (!"".equals(var22)) {
                     String var23 = TimeUtil.getCurrentDateString();
                     String var24 = TimeUtil.getOnlyCurrentTimeString();
                     DocTreeDocFieldComInfo var25 = new DocTreeDocFieldComInfo();
                     if (!var25.isHaveSameOne(var22, "" + var1.getId())) {
                        var15 = "insert into DocDummyDetail(catelogid,docid,importdate,importtime) values (" + var22 + "," + var1.getId() + ",'" + var23 + "','" + var24 + "')";
                        var21.executeSql(var15);
                     }
                  }
               }
            }

            return var8;
         } else {
            return 0;
         }
      }
   }

   private void updateDocInfo(DocInfo var1, User var2) throws Exception {
      DocDetailLog var3 = new DocDetailLog();
      String var4 = "";
      ConnStatement var5 = new ConnStatement();
      boolean var6 = var5.getDBType().equals("oracle");
      if (var6) {
         var4 = "update DocDetail set maincategory=?,subcategory=?,seccategory=?,doclangurage=?,docapprovable=?,docreplyable=?,isreply=?,replydocid=?,docsubject=?,docpublishtype=?,itemid=?,itemmaincategoryid=?,hrmresid=?,crmid=?,projectid=?,financeid=?,doccreaterid=?,docdepartmentid=?,doccreatedate=?,doccreatetime=?,doclastmoduserid=?,doclastmoddate=?,doclastmodtime=?,docapproveuserid=?,docapprovedate=?,docapprovetime=?,docarchiveuserid=?,docarchivedate=?,docarchivetime=?,docstatus=?,assetid=?,ownerid=?,keyword=?,accessorycount=accessorycount+?,replaydoccount=?,usertype=? ,cancopy=?,canremind=? ,doccode=?,docedition=?,doceditionid=?,ishistory=?,approveType=?,maindoc=?,readoptercanprint=?,docvaliduserid=?,docvaliddate=?,docvalidtime=?,docpubuserid=?,docpubdate=?,docpubtime=?,docreopenuserid=?,docreopendate=?,docreopentime=?,docinvaluserid=?,docinvaldate=?,docinvaltime=?,doccanceluserid=?,doccanceldate=?,doccanceltime=?,selectedpubmouldid=?,invalidationdate=?,docCreaterType=?,docLastModUserType=?,docApproveUserType=?,docValidUserType=?,docInvalUserType=?,docArchiveUserType=?,docCancelUserType=?,docPubUserType=?,docReopenUserType=?,ownerType=?,canPrintedNum=? where id=?";

         try {
            var5.setStatementSql(var4);
            var5.setInt(1, var1.getMaincategory());
            var5.setInt(2, var1.getSubcategory());
            var5.setInt(3, var1.getSeccategory());
            var5.setInt(4, var1.getDoclangurage());
            var5.setString(5, "");
            var5.setString(6, "");
            var5.setString(7, var1.getIsreply());
            var5.setInt(8, var1.getReplydocid());
            var5.setString(9, var1.getDocSubject());
            var5.setString(10, var1.getDocPublishType() < 0 ? "" : var1.getDocPublishType() + "");
            var5.setInt(11, var1.getItemid());
            var5.setInt(12, 0);
            var5.setInt(13, var1.getHrmresid());
            var5.setInt(14, var1.getCrmid());
            var5.setInt(15, var1.getProjectid());
            var5.setInt(16, var1.getFinanceid());
            var5.setInt(17, var1.getDoccreaterid());
            var5.setInt(18, var1.getDocdepartmentid());
            var5.setString(19, var1.getDoccreatedate());
            var5.setString(20, var1.getDoccreatetime());
            var5.setInt(21, var1.getDoclastmoduserid());
            var5.setString(22, var1.getDoclastmoddate());
            var5.setString(23, var1.getDoclastmodtime());
            var5.setInt(24, var1.getDocapproveuserid());
            var5.setString(25, var1.getDocapprovedate());
            var5.setString(26, var1.getDocapprovetime());
            var5.setInt(27, var1.getDocarchiveuserid());
            var5.setString(28, var1.getDocarchivedate());
            var5.setString(29, var1.getDocarchivetime());
            var5.setString(30, var1.getDocStatus() < 0 ? "" : var1.getDocStatus() + "");
            var5.setInt(31, var1.getAssetid());
            var5.setInt(32, var1.getOwnerid());
            var5.setString(33, var1.getKeyword());
            var5.setInt(34, var1.getAccessorycount());
            var5.setInt(35, var1.getReplaydoccount());
            var5.setString(36, var1.getDoccreatertype() < 0 ? "" : var1.getDoccreatertype() + "");
            var5.setString(37, "");
            var5.setString(38, "");
            var5.setString(39, var1.getDocCode());
            var5.setInt(40, var1.getDocEdition());
            var5.setInt(41, var1.getDocEditionId());
            var5.setInt(42, 0);
            var5.setInt(43, 0);
            var5.setInt(44, var1.getMaindoc());
            var5.setInt(45, 0);
            var5.setInt(46, 0);
            var5.setString(47, "");
            var5.setString(48, "");
            var5.setInt(49, 0);
            var5.setString(50, "");
            var5.setString(51, "");
            var5.setInt(52, 0);
            var5.setString(53, "");
            var5.setString(54, "");
            var5.setInt(55, var1.getDocinvaluserid());
            var5.setString(56, var1.getDocinvaldate());
            var5.setString(57, var1.getDocinvaltime());
            var5.setInt(58, var1.getDoccanceluserid());
            var5.setString(59, var1.getDoccanceldate());
            var5.setString(60, var1.getDoccanceltime());
            var5.setInt(61, 0);
            var5.setString(62, var1.getInvalidationdate());
            var5.setString(63, var1.getDoccreatertype() < 0 ? "" : var1.getDoccreatertype() + "");
            var5.setString(64, var1.getDoclastmodusertype() < 0 ? "" : var1.getDoclastmodusertype() + "");
            var5.setString(65, var1.getDocapproveusertype() < 0 ? "" : var1.getDocapproveusertype() + "");
            var5.setString(66, "");
            var5.setString(67, var1.getDocinvalusertype() < 0 ? "" : var1.getDocinvalusertype() + "");
            var5.setString(68, var1.getDocarchiveusertype() < 0 ? "" : var1.getDocarchiveusertype() + "");
            var5.setString(69, var1.getDoccancelusertype() < 0 ? "" : var1.getDoccancelusertype() + "");
            var5.setString(70, "");
            var5.setString(71, "");
            var5.setString(72, var1.getOwnertype() < 0 ? "" : var1.getOwnertype() + "");
            var5.setInt(73, 0);
            var5.setInt(74, var1.getId());
            var5.executeUpdate();
            var4 = "update DocDetailContent set doccontent=empty_clob() where docid=? ";
            var5.setStatementSql(var4);
            var5.setInt(1, var1.getId());
            var5.executeUpdate();
            var4 = "select doccontent from DocDetailContent where docid = " + var1.getId();
            var5.setStatementSql(var4, false);
            var5.executeQuery();
            var5.next();
            CLOB var7 = var5.getClob(1);
            String var8 = var1.getDoccontent();
            char[] var9 = var8.toCharArray();
            Writer var10 = var7.getCharacterOutputStream();
            var10.write(var9);
            var10.flush();
            var10.close();
            var3.resetParameter();
            var3.setDocId(var1.getId());
            var3.setDocSubject(var1.getDocSubject());
            var3.setOperateType("2");
            var3.setOperateUserid(var2.getUID());
            var3.setUsertype(var2.getLogintype());
            var3.setClientAddress(var2.getLoginip());
            var3.setDocCreater(var1.getDoccreaterid());
            var3.setCreatertype(var1.getDoccreatertype() + "");
            var3.setDocLogInfo();
         } catch (Exception var34) {
            this.writeLog(var34);
            throw var34;
         } finally {
            try {
               var5.close();
            } catch (Exception var30) {
            }

         }
      } else {
         var4 = "update DocDetail set maincategory=?,subcategory=?,seccategory=?,doclangurage=?,docapprovable=?,docreplyable=?,isreply=?,replydocid=?,docsubject=?,doccontent=?,docpublishtype=?,itemid=?,itemmaincategoryid=?,hrmresid=?,crmid=?,projectid=?,financeid=?,doccreaterid=?,docdepartmentid=?,doccreatedate=?,doccreatetime=?,doclastmoduserid=?,doclastmoddate=?,doclastmodtime=?,docapproveuserid=?,docapprovedate=?,docapprovetime=?,docarchiveuserid=?,docarchivedate=?,docarchivetime=?,docstatus=?,assetid=?,ownerid=?,keyword=?,accessorycount=accessorycount+?,replaydoccount=?,usertype=?,cancopy=?,canremind=?,doccode=?,docedition=?,doceditionid=?,ishistory=?,approveType=?,maindoc=?,readoptercanprint=?,docvaliduserid=?,docvaliddate=?,docvalidtime=?,docpubuserid=?,docpubdate=?,docpubtime=?,docreopenuserid=?,docreopendate=?,docreopentime=?,docinvaluserid=?,docinvaldate=?,docinvaltime=?,doccanceluserid=?,doccanceldate=?,doccanceltime=?,selectedpubmouldid=?,invalidationdate=?,docCreaterType=?,docLastModUserType=?,docApproveUserType=?,docValidUserType=?,docInvalUserType=?,docArchiveUserType=?,docCancelUserType=?,docPubUserType=?,docReopenUserType=?,ownerType=?,canPrintedNum=? where id=?";

         try {
            var5.setStatementSql(var4);
            var5.setInt(1, var1.getMaincategory());
            var5.setInt(2, var1.getSubcategory());
            var5.setInt(3, var1.getSeccategory());
            var5.setInt(4, var1.getDoclangurage());
            var5.setString(5, "");
            var5.setString(6, "");
            var5.setString(7, var1.getIsreply());
            var5.setInt(8, var1.getReplydocid());
            var5.setString(9, var1.getDocSubject());
            var5.setString(10, var1.getDoccontent());
            var5.setString(11, var1.getDocPublishType() < 0 ? "" : var1.getDocPublishType() + "");
            var5.setInt(12, var1.getItemid());
            var5.setInt(13, 0);
            var5.setInt(14, var1.getHrmresid());
            var5.setInt(15, var1.getCrmid());
            var5.setInt(16, var1.getProjectid());
            var5.setInt(17, var1.getFinanceid());
            var5.setInt(18, var1.getDoccreaterid());
            var5.setInt(19, var1.getDocdepartmentid());
            var5.setString(20, var1.getDoccreatedate());
            var5.setString(21, var1.getDoccreatetime());
            var5.setInt(22, var1.getDoclastmoduserid());
            var5.setString(23, var1.getDoclastmoddate());
            var5.setString(24, var1.getDoclastmodtime());
            var5.setInt(25, var1.getDocapproveuserid());
            var5.setString(26, var1.getDocapprovedate());
            var5.setString(27, var1.getDocapprovetime());
            var5.setInt(28, var1.getDocarchiveuserid());
            var5.setString(29, var1.getDocarchivedate());
            var5.setString(30, var1.getDocarchivetime());
            var5.setString(31, var1.getDocStatus() < 0 ? "" : var1.getDocStatus() + "");
            var5.setInt(32, var1.getAssetid());
            var5.setInt(33, var1.getOwnerid());
            var5.setString(34, var1.getKeyword());
            var5.setInt(35, var1.getAccessorycount());
            var5.setInt(36, var1.getReplaydoccount());
            var5.setString(37, var1.getDoccreatertype() < 0 ? "" : var1.getDoccreatertype() + "");
            var5.setString(38, "");
            var5.setString(39, "");
            var5.setString(40, var1.getDocCode());
            var5.setInt(41, var1.getDocEdition());
            var5.setInt(42, var1.getDocEditionId());
            var5.setInt(43, 0);
            var5.setInt(44, 0);
            var5.setInt(45, var1.getMaindoc());
            var5.setInt(46, 0);
            var5.setInt(47, 0);
            var5.setString(48, "");
            var5.setString(49, "");
            var5.setInt(50, 0);
            var5.setString(51, "");
            var5.setString(52, "");
            var5.setInt(53, 0);
            var5.setString(54, "");
            var5.setString(55, "");
            var5.setInt(56, var1.getDocinvaluserid());
            var5.setString(57, var1.getDocinvaldate());
            var5.setString(58, var1.getDocinvaltime());
            var5.setInt(59, var1.getDoccanceluserid());
            var5.setString(60, var1.getDoccanceldate());
            var5.setString(61, var1.getDoccanceltime());
            var5.setInt(62, 0);
            var5.setString(63, var1.getInvalidationdate());
            var5.setString(64, var1.getDoccreatertype() < 0 ? "" : var1.getDoccreatertype() + "");
            var5.setString(65, var1.getDoclastmodusertype() < 0 ? "" : var1.getDoclastmodusertype() + "");
            var5.setString(66, var1.getDocapproveusertype() < 0 ? "" : var1.getDocapproveusertype() + "");
            var5.setString(67, "");
            var5.setString(68, var1.getDocinvalusertype() < 0 ? "" : var1.getDocinvalusertype() + "");
            var5.setString(69, var1.getDocarchiveusertype() < 0 ? "" : var1.getDocarchiveusertype() + "");
            var5.setString(70, var1.getDoccancelusertype() < 0 ? "" : var1.getDoccancelusertype() + "");
            var5.setString(71, "");
            var5.setString(72, "");
            var5.setString(73, var1.getOwnertype() < 0 ? "" : var1.getOwnertype() + "");
            var5.setInt(74, 0);
            var5.setInt(75, var1.getId());
            var5.executeUpdate();
            var3.resetParameter();
            var3.setDocId(var1.getId());
            var3.setDocSubject(var1.getDocSubject());
            var3.setOperateType("2");
            var3.setOperateUserid(var2.getUID());
            var3.setUsertype(var2.getLogintype());
            var3.setClientAddress(var2.getLoginip());
            var3.setDocCreater(var1.getDoccreaterid());
            var3.setCreatertype(var1.getDoccreatertype() < 0 ? "" : var1.getDoccreatertype() + "");
            var3.setDocLogInfo();
         } catch (Exception var32) {
            this.writeLog(var32);
            throw var32;
         } finally {
            try {
               var5.close();
            } catch (Exception var31) {
            }

         }
      }

   }

   public int deleteDoc(int var1, String var2) throws Exception {
      User var3 = (User)gutSessionId(var2);
      return this.deleteDocByUser(var1, var3);
   }

   public int deleteDocByUser(int var1, User var2) throws Exception {
      DocInfo var3 = this.getDocByUser(var1, var2, "");
      if (var2 != null && this.getRight(var3, var2, 3)) {
         try {
            ShareManager var4 = new ShareManager();
            DocComInfo var5 = new DocComInfo();
            RecordSet var6 = new RecordSet();
            String var7 = "delete from DocDetail where id=" + var1;
            String var8 = "delete from DocShare where docid=" + var1;
            String var9 = "delete from " + var4.getTableName("doc", "inner") + " where sourceid=" + var1;
            String var10 = "delete from " + var4.getTableName("doc", "outer") + " where sourceid=" + var1;
            String var11 = "delete from DocImageFile where docid=" + var1;
            String var12 = "delete from docreadtag where docid=" + var1;
            String var13 = "delete from DocDetailLog where docid=" + var1;
            DocImageManager var14 = new DocImageManager();
            var14.setDocid(var1);
            var14.DeleteAllDocImageInfo();
            var6.executeSql(var7);
            var6.executeSql(var8);
            var6.executeSql(var9);
            var6.executeSql(var10);
            var6.executeSql(var11);
            var6.executeSql(var12);
            var6.executeSql(var13);
            var5.deleteDocInfoCache("" + var1);
            return 1;
         } catch (Exception var15) {
            this.writeLog(var15.toString());
         }
      }

      return 0;
   }

   public DocInfo getDoc(int var1, String var2) throws Exception {
      User var3 = (User)gutSessionId(var2);
      return this.getDocByUser(var1, var3, "");
   }

   public DocInfo getDocByUser(int var1, User var2, String var3) throws Exception {
      DocInfo var4 = new DocInfo();
      var4.setId(var1);
      if (!this.getRight(var4, var2, 1)) {
         return null;
      } else {
         var3 = Util.null2String(var3);
         var3 = "," + var3 + ",";
         if (var2 != null) {
            RecordSet var5 = new RecordSet();
            DocComInfo var6 = new DocComInfo();
            MainCategoryComInfo var7 = new MainCategoryComInfo();
            SubCategoryComInfo var8 = new SubCategoryComInfo();
            SecCategoryComInfo var9 = new SecCategoryComInfo();
            DepartmentComInfo var10 = new DepartmentComInfo();
            LanguageComInfo var11 = new LanguageComInfo();
            CustomerInfoComInfo var12 = new CustomerInfoComInfo();
            ResourceComInfo var13 = new ResourceComInfo();
            String var14 = "";
            if (var5.getDBType().equals("oracle")) {
               var14 = " select t1.* , t2.doccontent from DocDetail t1 , DocDetailContent t2 where t1.id = t2.docid and ";
            } else {
               var14 = " select * from DocDetail t1 where ";
            }

            var14 = var14 + " t1.id = " + var1;
            var5.executeSql(var14);
            if (var5.next()) {
               var4.setDocType(Util.getIntValue(Util.null2String(var5.getString("doctype")), 1));
               String var15 = Util.null2String(var5.getString("docsubject"));
               var15 = var15.replaceAll("\n", "");
               var4.setDocSubject(var15);
               var4.setDocCode(Util.null2String(var5.getString("docCode")));
               var4.setDocPublishType(Util.getIntValue(Util.null2String(var5.getString("docpublishtype")), 1));
               String var16 = "";
               if (var4.getDocPublishType() == 2) {
                  var16 = SystemEnv.getHtmlLabelName(227, var2.getLanguage());
               } else if (var4.getDocPublishType() == 3) {
                  var16 = SystemEnv.getHtmlLabelName(229, var2.getLanguage());
               } else {
                  var16 = SystemEnv.getHtmlLabelName(58, var2.getLanguage());
               }

               var4.setPublishable(var16);
               var4.setDocEdition(Util.getIntValue(Util.null2String(var5.getString("docEdition")), 0));
               var4.setDocEditionId(Util.getIntValue(Util.null2String(var5.getString("docEditionId"))));
               var4.setDocEditionStr(var6.getEditionView(var4.getId()));
               var4.setDocStatus(Util.getIntValue(Util.null2String(var5.getString("docstatus"))));
               var4.setDocStatusStr(var6.getStatusView(var4.getId(), var2));
               var4.setMaincategory(var5.getInt("maincategory"));
               var4.setMaincategoryStr(var7.getMainCategoryname(var4.getMaincategory() + ""));
               var4.setSubcategory(var5.getInt("subcategory"));
               var4.setSubcategoryStr(var8.getSubCategoryname(var4.getSubcategory() + ""));
               var4.setSeccategory(var5.getInt("seccategory"));
               var4.setSeccategoryStr(var9.getSecCategoryname(var4.getSeccategory() + ""));
               var4.setAllParentName(var9.getAllParentName(var4.getSeccategory() + "", true));
               var4.setDocdepartmentid(var5.getInt("docdepartmentid"));
               var4.setDocdepartmentStr(var10.getDepartmentname(var4.getDocdepartmentid() + ""));
               var4.setDoclangurage(var5.getInt("doclangurage"));
               var4.setDoclangurageStr(var11.getLanguagename(var4.getDoclangurage() + ""));
               var4.setKeyword(Util.null2String(var5.getString("keyword")));
               var4.setDoccreaterid(var5.getInt("doccreaterid"));
               var4.setDoccreatertype(Util.getIntValue(Util.null2String(var5.getString("docCreaterType"))));
               var4.setDoccreatername(var4.getDoccreatertype() == 1 ? var13.getResourcename(var4.getDoccreaterid() + "") : var12.getCustomerInfoname(var4.getDoccreaterid() + ""));
               var4.setDoccreatedate(Util.null2String(var5.getString("doccreatedate")));
               var4.setDoccreatetime(Util.null2String(var5.getString("doccreatetime")));
               var4.setDoclastmoduserid(var5.getInt("doclastmoduserid"));
               var4.setDoclastmodusertype(Util.getIntValue(Util.null2String(var5.getString("docLastModUserType"))));
               var4.setDoclastmodusername(var4.getDoclastmodusertype() == 1 ? var13.getResourcename(var4.getDoclastmoduserid() + "") : var12.getCustomerInfoname(var4.getDoclastmoduserid() + ""));
               var4.setDoclastmoddate(Util.null2String(var5.getString("doclastmoddate")));
               var4.setDoclastmodtime(Util.null2String(var5.getString("doclastmodtime")));
               var4.setDocapproveuserid(var5.getInt("docapproveuserid"));
               var4.setDocapproveusertype(Util.getIntValue(Util.null2String(var5.getString("docApproveUserType"))));
               var4.setDocapproveusername(var4.getDocapproveusertype() == 1 ? var13.getResourcename(var4.getDocapproveuserid() + "") : var12.getCustomerInfoname(var4.getDocapproveuserid() + ""));
               var4.setDocapprovedate(Util.null2String(var5.getString("docapprovedate")));
               var4.setDocapprovetime(Util.null2String(var5.getString("docapprovetime")));
               var4.setDocinvaluserid(var5.getInt("docInvalUserId"));
               var4.setDocinvalusertype(Util.getIntValue(Util.null2String(var5.getString("docInvalUserType"))));
               var4.setDocinvalusername(var4.getDocinvalusertype() == 1 ? var13.getResourcename(var4.getDocinvaluserid() + "") : var12.getCustomerInfoname(var4.getDocinvaluserid() + ""));
               var4.setDocinvaldate(Util.null2String(var5.getString("docInvalDate")));
               var4.setDocinvaltime(Util.null2String(var5.getString("docInvalTime")));
               var4.setDocarchiveuserid(var5.getInt("docarchiveuserid"));
               var4.setDocarchiveusertype(Util.getIntValue(Util.null2String(var5.getString("docArchiveUserType"))));
               var4.setDocarchiveusername(var4.getDocarchiveusertype() == 1 ? var13.getResourcename(var4.getDocarchiveuserid() + "") : var12.getCustomerInfoname(var4.getDocarchiveuserid() + ""));
               var4.setDocarchivedate(Util.null2String(var5.getString("docarchivedate")));
               var4.setDocarchivetime(Util.null2String(var5.getString("docarchivetime")));
               var4.setDoccanceluserid(var5.getInt("docCancelUserId"));
               var4.setDoccancelusertype(Util.getIntValue(Util.null2String(var5.getString("docCancelUserType"))));
               var4.setDoccancelusername(var4.getDoccancelusertype() == 1 ? var13.getResourcename(var4.getDoccanceluserid() + "") : var12.getCustomerInfoname(var4.getDoccanceluserid() + ""));
               var4.setDoccanceldate(Util.null2String(var5.getString("docCancelDate")));
               var4.setDoccanceltime(Util.null2String(var5.getString("docCancelTime")));
               var4.setMaindoc(var5.getInt("mainDoc"));
               var4.setMaindocname(var4.getMaindoc() == var4.getId() ? SystemEnv.getHtmlLabelName(524, var2.getLanguage()) + SystemEnv.getHtmlLabelName(58, var2.getLanguage()) : var6.getDocname(var4.getMaindoc() + ""));
               Map var17;
               if (var3.indexOf(",getChildDocInfo,") == -1) {
                  var17 = this.getChildDocInfo(var4);
                  var4.setChilddoc((int[])((int[])var17.get("childdocids")));
                  var4.setChiledocname((String[])((String[])var17.get("chiledocnames")));
               }

               var4.setOwnerid(var5.getInt("ownerid"));
               var4.setOwnertype(Util.getIntValue(Util.null2String(var5.getString("ownerType"))));
               var4.setOwnername(var4.getOwnertype() == 1 ? var13.getResourcename(var4.getOwnerid() + "") : var12.getCustomerInfoname(var4.getOwnerid() + ""));
               var4.setInvalidationdate(Util.null2String(var5.getString("invalidationdate")));
               if (var3.indexOf(",getDummy,") == -1) {
                  var17 = this.getDummy(var4);
                  var4.setDummyIds((int[])((int[])var17.get("dummyIds")));
                  var4.setDummyNames((String[])((String[])var17.get("dummyNames")));
               }

               var4.setDoccustomfields(this.getCustomFieldInfo(var4, var2));
               var4.setHrmresid(var5.getInt("hrmresid"));
               var4.setAssetid(var5.getInt("assetid"));
               var4.setCrmid(var5.getInt("hrmresid"));
               var4.setItemid(var5.getInt("itemid"));
               var4.setProjectid(var5.getInt("projectid"));
               var4.setFinanceid(var5.getInt("financeid"));
               if (var3.indexOf(",getDoccontent,") == -1) {
                  String var19 = Util.toBaseEncoding(var5.getString("doccontent"), var2.getLanguage(), "1");
                  if (var4.getDocPublishType() == 2) {
                     int var18 = var19.indexOf("!@#$%^&*");
                     if (var18 != -1) {
                        var19 = var19.substring(var18 + 8, var19.length());
                     }
                  }

                  var4.setDoccontent(var19);
               }

               if (var3.indexOf(",getExtDocInfo,") == -1 && var4.getDocType() == 2) {
                  var17 = this.getExtDocInfo(var4);
                  var4.setVersionId(Util.getIntValue((String)var17.get("versionId")));
                  var4.setImagefileId(Util.getIntValue((String)var17.get("imageFileId")));
               }

               var4.setIsreply(var5.getString("isreply"));
               var4.setReplydocid(var5.getInt("replydocid"));
               var4.setAccessorycount(var5.getInt("accessorycount"));
               var4.setReplaydoccount(var5.getInt("replaydoccount"));
               DocAttachment[] var20;
               if (var3.indexOf(",getAttachment,") == -1) {
                  var20 = this.getAttachment(var4);
                  var4.setAttachments(var20);
               }

               if (var3.indexOf(",getPictures,") == -1) {
                  var20 = this.getPictures(var4);
                  var4.setPictures(var20);
               }
            }
         }

         return var4;
      }
   }

   public int getDocCount(String var1) throws Exception {
      User var2 = (User)gutSessionId(var1);
      return this.getDocCountByUser(var2);
   }

   public int getDocCountByUser(User var1) throws Exception {
      if (var1 != null) {
         RecordSet var2 = new RecordSet();
         ShareManager var3 = new ShareManager();
         String var4 = "";
         if (var2.getDBType().equals("oracle")) {
            var4 = " from DocDetail t1," + var3.getShareDetailTableByUser("doc", var1) + " t2,DocDetailContent t3 where t1.id = t2.sourceid and t1.id = t3.docid ";
         } else {
            var4 = " from DocDetail t1," + var3.getShareDetailTableByUser("doc", var1) + " t2 where t1.id = t2.sourceid ";
         }

         var4 = var4 + " and ((docstatus = 7 and (sharelevel>1 or (t1.doccreaterid=" + var1.getUID() + ")) ) or t1.docstatus in ('1','2','5')) ";
         var4 = var4 + "  and seccategory!=0 and (ishistory is null or ishistory = 0) ";
         var4 = " select count(*) as c " + var4;
         this.writeLog("getDocCount: sql = " + var4);
         var2.executeSql(var4);
         if (var2.next()) {
            return var2.getInt("c");
         }
      }

      return 0;
   }

   public DocInfo[] getList(String var1, int var2, int var3) throws Exception {
      User var4 = (User)gutSessionId(var1);
      ArrayList var5 = new ArrayList();
      if (var4 != null) {
         RecordSet var6 = new RecordSet();
         ShareManager var7 = new ShareManager();
         DocComInfo var8 = new DocComInfo();
         MainCategoryComInfo var9 = new MainCategoryComInfo();
         SubCategoryComInfo var10 = new SubCategoryComInfo();
         SecCategoryComInfo var11 = new SecCategoryComInfo();
         DepartmentComInfo var12 = new DepartmentComInfo();
         LanguageComInfo var13 = new LanguageComInfo();
         CustomerInfoComInfo var14 = new CustomerInfoComInfo();
         ResourceComInfo var15 = new ResourceComInfo();
         String var16 = "";
         if (var6.getDBType().equals("oracle")) {
            var16 = " t1.*,t2.sharelevel,t3.doccontent from DocDetail t1," + var7.getShareDetailTableByUser("doc", var4) + " t2,DocDetailContent t3 where t1.id = t2.sourceid and t1.id = t3.docid ";
         } else {
            var16 = " t1.*,t2.sharelevel from DocDetail t1," + var7.getShareDetailTableByUser("doc", var4) + " t2 where t1.id = t2.sourceid ";
         }

         var16 = var16 + " and ((docstatus = 7 and (sharelevel>1 or (t1.doccreaterid=" + var4.getUID() + ")) ) or t1.docstatus in ('1','2','5')) ";
         var16 = var16 + "  and seccategory!=0 and (ishistory is null or ishistory = 0) ";
         var16 = var16 + " order by doclastmoddate desc,doclastmodtime desc,id desc";
         boolean var17 = false;
         boolean var18 = false;
         String var22;
         String var23;
         if (var2 > 0 && var3 > 0) {
            if (var6.getDBType().equals("oracle")) {
               var16 = " select " + var16;
               var16 = "select * from ( select row_.*, rownum rownum_ from ( " + var16 + " ) row_ where rownum <= " + (var2 * var3 + var3) + ") where rownum_ > " + var2 * var3;
            } else if (var2 > 1) {
               int var29 = var3 * var2;
               int var30 = var3;
               int var21 = this.getDocCountByUser(var4);
               if (var29 > var21) {
                  var29 = var21;
                  var30 = var21 - var3 * (var2 - 1);
               }

               var22 = "order by doclastmoddate asc,doclastmodtime asc,id asc";
               var23 = "order by doclastmoddate desc,doclastmodtime desc,id desc";
               var16 = " select top " + var30 + " * from ( select top " + var30 + " * from (  select  top " + var29 + " " + var16 + " " + ") tbltemp1 " + var22 + " ) tbltemp2 " + var23;
            } else {
               var16 = " select top " + var3 + var16;
            }
         } else {
            var16 = " select " + var16;
         }

         var6.executeSql(var16);

         while(var6.next()) {
            DocInfo var31 = new DocInfo();
            var31.setId(Util.getIntValue(Util.null2String(var6.getString("id"))));
            var31.setDocType(Util.getIntValue(Util.null2String(var6.getString("doctype")), 1));
            var22 = Util.null2String(var6.getString("docsubject"));
            var22 = var22.replaceAll("\n", "");
            var31.setDocSubject(var22);
            var31.setDocCode(Util.null2String(var6.getString("docCode")));
            var31.setDocPublishType(Util.getIntValue(Util.null2String(var6.getString("docpublishtype")), 1));
            var23 = "";
            if (var31.getDocPublishType() == 2) {
               var23 = SystemEnv.getHtmlLabelName(227, var4.getLanguage());
            } else if (var31.getDocPublishType() == 3) {
               var23 = SystemEnv.getHtmlLabelName(229, var4.getLanguage());
            } else {
               var23 = SystemEnv.getHtmlLabelName(58, var4.getLanguage());
            }

            var31.setPublishable(var23);
            var31.setDocEdition(Util.getIntValue(Util.null2String(var6.getString("docEdition")), 0));
            var31.setDocEditionId(Util.getIntValue(Util.null2String(var6.getString("docEditionId"))));
            var31.setDocEditionStr(var8.getEditionView(var31.getId()));
            var31.setDocStatus(Util.getIntValue(Util.null2String(var6.getString("docstatus"))));
            var31.setDocStatusStr(var8.getStatusView(var31.getId(), var4));
            var31.setMaincategory(var6.getInt("maincategory"));
            var31.setMaincategoryStr(var9.getMainCategoryname(var31.getMaincategory() + ""));
            var31.setSubcategory(var6.getInt("subcategory"));
            var31.setSubcategoryStr(var10.getSubCategoryname(var31.getSubcategory() + ""));
            var31.setSeccategory(var6.getInt("seccategory"));
            var31.setSeccategoryStr(var11.getSecCategoryname(var31.getSeccategory() + ""));
            var31.setDocdepartmentid(var6.getInt("docdepartmentid"));
            var31.setDocdepartmentStr(var12.getDepartmentname(var31.getDocdepartmentid() + ""));
            var31.setDoclangurage(var6.getInt("doclangurage"));
            var31.setDoclangurageStr(var13.getLanguagename(var31.getDoclangurage() + ""));
            var31.setKeyword(Util.null2String(var6.getString("keyword")));
            var31.setDoccreaterid(var6.getInt("doccreaterid"));
            var31.setDoccreatertype(Util.getIntValue(Util.null2String(var6.getString("docCreaterType"))));
            var31.setDoccreatername(var31.getDoccreatertype() == 1 ? var15.getResourcename(var31.getDoccreaterid() + "") : var14.getCustomerInfoname(var31.getDoccreaterid() + ""));
            var31.setDoccreatedate(Util.null2String(var6.getString("doccreatedate")));
            var31.setDoccreatetime(Util.null2String(var6.getString("doccreatetime")));
            var31.setDoclastmoduserid(var6.getInt("doclastmoduserid"));
            var31.setDoclastmodusertype(Util.getIntValue(Util.null2String(var6.getString("docLastModUserType"))));
            var31.setDoclastmodusername(var31.getDoclastmodusertype() == 1 ? var15.getResourcename(var31.getDoclastmoduserid() + "") : var14.getCustomerInfoname(var31.getDoclastmoduserid() + ""));
            var31.setDoclastmoddate(Util.null2String(var6.getString("doclastmoddate")));
            var31.setDoclastmodtime(Util.null2String(var6.getString("doclastmodtime")));
            var31.setDocapproveuserid(var6.getInt("docapproveuserid"));
            var31.setDocapproveusertype(Util.getIntValue(Util.null2String(var6.getString("docApproveUserType"))));
            var31.setDocapproveusername(var31.getDocapproveusertype() == 1 ? var15.getResourcename(var31.getDocapproveuserid() + "") : var14.getCustomerInfoname(var31.getDocapproveuserid() + ""));
            var31.setDocapprovedate(Util.null2String(var6.getString("docapprovedate")));
            var31.setDocapprovetime(Util.null2String(var6.getString("docapprovetime")));
            var31.setDocinvaluserid(var6.getInt("docInvalUserId"));
            var31.setDocinvalusertype(Util.getIntValue(Util.null2String(var6.getString("docInvalUserType"))));
            var31.setDocinvalusername(var31.getDocinvalusertype() == 1 ? var15.getResourcename(var31.getDocinvaluserid() + "") : var14.getCustomerInfoname(var31.getDocinvaluserid() + ""));
            var31.setDocinvaldate(Util.null2String(var6.getString("docInvalDate")));
            var31.setDocinvaltime(Util.null2String(var6.getString("docInvalTime")));
            var31.setDocarchiveuserid(var6.getInt("docarchiveuserid"));
            var31.setDocarchiveusertype(Util.getIntValue(Util.null2String(var6.getString("docArchiveUserType"))));
            var31.setDocarchiveusername(var31.getDocarchiveusertype() == 1 ? var15.getResourcename(var31.getDocarchiveuserid() + "") : var14.getCustomerInfoname(var31.getDocarchiveuserid() + ""));
            var31.setDocarchivedate(Util.null2String(var6.getString("docarchivedate")));
            var31.setDocarchivetime(Util.null2String(var6.getString("docarchivetime")));
            var31.setDoccanceluserid(var6.getInt("docCancelUserId"));
            var31.setDoccancelusertype(Util.getIntValue(Util.null2String(var6.getString("docCancelUserType"))));
            var31.setDoccancelusername(var31.getDoccancelusertype() == 1 ? var15.getResourcename(var31.getDoccanceluserid() + "") : var14.getCustomerInfoname(var31.getDoccanceluserid() + ""));
            var31.setDoccanceldate(Util.null2String(var6.getString("docCancelDate")));
            var31.setDoccanceltime(Util.null2String(var6.getString("docCancelTime")));
            var31.setMaindoc(var6.getInt("mainDoc"));
            var31.setMaindocname(var31.getMaindoc() == var31.getId() ? SystemEnv.getHtmlLabelName(524, var4.getLanguage()) + SystemEnv.getHtmlLabelName(58, var4.getLanguage()) : var8.getDocname(var31.getMaindoc() + ""));
            Map var24 = this.getChildDocInfo(var31);
            var31.setChilddoc((int[])((int[])var24.get("childdocids")));
            var31.setChiledocname((String[])((String[])var24.get("chiledocnames")));
            var31.setOwnerid(var6.getInt("ownerid"));
            var31.setOwnertype(Util.getIntValue(Util.null2String(var6.getString("ownerType"))));
            var31.setOwnername(var31.getOwnertype() == 1 ? var15.getResourcename(var31.getOwnerid() + "") : var14.getCustomerInfoname(var31.getOwnerid() + ""));
            var31.setInvalidationdate(Util.null2String(var6.getString("invalidationdate")));
            Map var25 = this.getDummy(var31);
            var31.setDummyIds((int[])((int[])var25.get("dummyIds")));
            var31.setDummyNames((String[])((String[])var25.get("dummyNames")));
            var31.setHrmresid(var6.getInt("hrmresid"));
            var31.setAssetid(var6.getInt("assetid"));
            var31.setCrmid(var6.getInt("hrmresid"));
            var31.setItemid(var6.getInt("itemid"));
            var31.setProjectid(var6.getInt("projectid"));
            var31.setFinanceid(var6.getInt("financeid"));
            if (var31.getDocType() == 2) {
               Map var26 = this.getExtDocInfo(var31);
               var31.setVersionId(Util.getIntValue((String)var26.get("versionId")));
               var31.setImagefileId(Util.getIntValue((String)var26.get("imageFileId")));
            }

            var31.setIsreply(var6.getString("isreply"));
            var31.setReplydocid(var6.getInt("replydocid"));
            var31.setAccessorycount(var6.getInt("accessorycount"));
            var31.setReplaydoccount(var6.getInt("replaydoccount"));
            var5.add(var31);
         }
      }

      DocInfo[] var27 = new DocInfo[var5.size()];

      for(int var28 = 0; var28 < var5.size(); ++var28) {
         var27[var28] = (DocInfo)var5.get(var28);
      }

      return var27;
   }

   private DocAttachment saveAttachment(DocAttachment var1) throws Exception {
      boolean var2 = false;
      var1 = this.writeAttachment(var1);
      if (var1 == null) {
         return null;
      } else {
         int var3 = var1.getImagefilesize();
         String var4 = var1.getFilerealpath();
         String var5 = "1";
         String var6 = var1.getIszip() + "";
         String var7 = "0";
         String var8 = var1.getFilename();
         String var9 = var1.getFiletype();
         int var10 = var1.getIsAesEncrype();
         String var11 = var1.getAesCode();
         RecordSet var12 = new RecordSet();
         char var13 = Util.getSeparator();
         int var19 = imageFileIdUpdate.getImageFileNewId();
         String var14 = "" + var19 + var13 + var8 + var13 + var9 + var13 + var5 + var13 + var4 + var13 + var6 + var13 + var7 + var13 + var3;
         var12.executeProc("ImageFile_Insert", var14);
         var12.executeSql("update ImageFile set isaesencrypt=" + var10 + ",aescode='" + var11 + "' where imagefileid=" + var19);
         var1.setImagefileid(var19);
         Object var15 = null;

         try {
            if (var9.indexOf("image") != -1) {
               File var16 = new File(var4);
               if (var1.getIszip() == 1) {
                  ZipInputStream var17 = new ZipInputStream(new FileInputStream(var16));
                  if (var17.getNextEntry() != null) {
                     var15 = new BufferedInputStream(var17);
                  }
               } else {
                  var15 = new BufferedInputStream(new FileInputStream(var16));
               }

               if (var10 == 1) {
                  var15 = AESCoder.decrypt((InputStream)var15, var11);
               }

               ImageInfo var20 = new ImageInfo();
               var20.setInput((InputStream)var15);
               if (!var20.check()) {
                  var1.setImagefilewidth(0);
                  var1.setImagefileheight(0);
               } else {
                  var1.setImagefilewidth(var20.getWidth());
                  var1.setImagefileheight(var20.getHeight());
               }
            } else {
               var1.setImagefilewidth(0);
               var1.setImagefileheight(0);
            }
         } catch (Exception var18) {
            var1.setImagefilewidth(0);
            var1.setImagefileheight(0);
         }

         return var1;
      }
   }

   private DocAttachment writeAttachment(DocAttachment var1) throws Exception {
      DefaultFileRenamePolicy var2 = new DefaultFileRenamePolicy();
      SystemComInfo var3 = new SystemComInfo();
      Object var4 = null;
      BufferedInputStream var5 = null;

      try {
         boolean var6 = false;
         if (var3.getNeedzip().equals("1")) {
            var6 = true;
         }

         var1.setIszip(var6 ? 1 : 0);
         String var7 = var3.getIsaesencrypt();
         String var8 = Util.getRandomString(13);
         var1.setIsAesEncrype(Util.getIntValue(var7, 0));
         var1.setAesCode(var8);
         if (var1.getFilecontent() != null && !"".equals(var1.getFilecontent())) {
            byte[] var22 = Base64.decode(var1.getFilecontent());
            var5 = new BufferedInputStream(new ByteArrayInputStream(var22));
         } else {
            File var9 = new File(var1.getFilerealpath());
            if (var1.getFilename() == null || "".equals(var1.getFilename())) {
               var1.setFilename(this.getFileMainName(var9.getName()));
            }

            var5 = new BufferedInputStream(new FileInputStream(var9));
         }

         String var23 = FileUpload.getCreateDir(var3.getFilesystem());
         if (var23 != null) {
            FileManage.createDir(var23);
         }

         String var10 = null;
         String var11 = null;
         var10 = Util.getRandom();
         if (var10 != null) {
            int var13;
            if (var6) {
               var11 = var10;
               String var12 = null;
               var13 = var10.lastIndexOf(".");
               if (var13 != -1) {
                  var12 = var10.substring(0, var13);
               } else {
                  var12 = var10;
               }

               var10 = var12 + ".zip";
            }

            File var24 = new File(new String(var23.getBytes("ISO8859_1"), "UTF-8"), new String(var10.getBytes("ISO8859_1"), "UTF-8"));
            var1.setFilerealpath(var24.getPath());
            if (var2 != null) {
               var24 = var2.rename(var24);
               new String(var24.getName().getBytes("UTF-8"), "ISO8859_1");
            }

            if (var6) {
               ZipOutputStream var25 = new ZipOutputStream(new BufferedOutputStream(new FileOutputStream(var24)));
               var25.setMethod(8);
               var25.putNextEntry(new ZipEntry(new String(var11.getBytes("UTF-8"), "ISO8859_1")));
               var4 = var25;
            } else {
               var4 = new BufferedOutputStream(new FileOutputStream(var24));
            }

            if (var7.equals("1")) {
               var4 = AESCoder.encrypt((OutputStream)var4, var8);
            }

            var13 = 0;

            int var14;
            for(byte[] var15 = new byte[8192]; (var14 = var5.read(var15)) != -1; var13 += var14) {
               ((OutputStream)var4).write(var15, 0, var14);
            }

            ((OutputStream)var4).flush();
            var1.setImagefilesize(var13);
            DocAttachment var16 = var1;
            return var16;
         }
      } catch (IOException var20) {
         this.writeLog("Write Attachment File Error:", var20);
      } finally {
         if (var4 != null) {
            ((OutputStream)var4).close();
         }

         if (var5 != null) {
            var5.close();
         }

      }

      return null;
   }

   private String getFileMainName(String var1) {
      if (var1 == null) {
         return "";
      } else {
         int var2 = var1.lastIndexOf(".");
         if (var2 != -1) {
            var1 = var1.substring(0, var2);
         }

         return var1;
      }
   }

   private String getFileExt(String var1) {
      if (var1 != null && !var1.trim().equals("")) {
         int var2 = var1.lastIndexOf(".");
         if (var2 == -1) {
            return "";
         } else {
            return var2 + 1 >= var1.length() ? "" : var1.substring(var2 + 1);
         }
      } else {
         return "";
      }
   }

   private boolean getRight(DocInfo var1, User var2, int var3) throws Exception {
      RecordSet var4 = new RecordSet();
      boolean var5 = false;
      DocManager var6 = new DocManager();
      String var7 = "";
      boolean var8 = false;
      boolean var9 = false;
      String var10 = "";
      var6.resetParameter();
      var6.setId(var1.getId());
      var6.getDocInfoById();
      var7 = var6.getDocstatus();
      int var24 = var6.getIsHistory();
      int var25 = var6.getSeccategory();
      var10 = var6.getDocpublishtype();
      String var11;
      String var12;
      String var13;
      if (var10 != null && (var10.equals("2") || var10.equals("3"))) {
         var11 = "";
         var12 = " select 1 from DocDetail where id=" + var1.getId() + " ";
         var13 = "";
         boolean var14 = false;
         var4.executeSql("select newsClause from DocFrontPage where publishType='0'");

         while(var4.next()) {
            var14 = true;
            var11 = Util.null2String(var4.getString("newsClause"));
            if (var11.equals("")) {
               var11 = " 1=1 ";
            }

            if (!var11.trim().equals("")) {
               var13 = var13 + " or (" + var11 + ")";
            }
         }

         if (!var13.equals("")) {
            var13 = var13.substring(var13.indexOf("("));
            var12 = var12 + " and (" + var13 + ") ";
         }

         if (var14) {
            var4.executeSql(var12);
            if (var4.next()) {
               var5 = true;
            }
         }
      }

      if (var2 == null) {
         return false;
      } else {
         var11 = "" + var2.getUID();
         var12 = var2.getLogintype();
         var13 = var2.getSeclevel();
         String var26 = "" + var2.getType();
         String var15 = "" + var2.getUserDepartment();
         String var16 = "" + var2.getUserSubCompany1();
         String var17 = var12 + "_" + var11 + "_" + var13 + "_" + var26 + "_" + var15 + "_" + var16;
         ArrayList var18 = null;
         SpopForDoc var19 = new SpopForDoc();
         var18 = var19.getDocOpratePopedom("" + var1.getId(), var17);
         SecCategoryComInfo var20 = new SecCategoryComInfo();
         boolean var21 = false;
         boolean var22 = false;
         boolean var23 = false;
         if (((String)var18.get(0)).equals("true")) {
            var21 = true;
         }

         if (((String)var18.get(1)).equals("true")) {
            var22 = true;
         }

         if (((String)var18.get(2)).equals("true")) {
            var23 = true;
         }

         if (!var21 || (!var22 || var7.equals("8")) && (!var7.equals("7") || var24 != 1 || !var20.isReaderCanViewHistoryEdition(var25)) && !var7.equals("1") && !var7.equals("2") && !var7.equals("3") && !var7.equals("9") && !var7.equals("0") && !var7.equals("5")) {
            var21 = false;
         } else {
            var21 = true;
         }

         if (var24 == 1) {
            if (var20.isReaderCanViewHistoryEdition(var25)) {
               if (var21 && !var22) {
                  var21 = true;
               }
            } else if (var21 && !var22) {
               var21 = false;
            }
         }

         if (var22 && (var7.equals("3") || var7.equals("5") || var7.equals("6") || var24 == 1)) {
            var22 = false;
            var21 = true;
         }

         if (var22 && (var7.equals("0") || var7.equals("1") || var7.equals("2") || var7.equals("7")) && var24 != 1) {
            var22 = true;
         } else {
            var22 = false;
         }

         if (var3 == 1) {
            return var21;
         } else if (var3 == 2) {
            return var5;
         } else {
            return var3 == 3 ? var23 : var22;
         }
      }
   }

   private DocAttachment[] getAttachment(DocInfo var1) throws Exception {
      ArrayList var2 = new ArrayList();
      ImageFileManager var3 = new ImageFileManager();
      DocImageManager var4 = new DocImageManager();
      var4.resetParameter();
      var4.setDocid(var1.getId());
      var4.selectDocImageInfo2();

      while(true) {
         int var5;
         do {
            if (!var4.next()) {
               DocAttachment[] var18 = new DocAttachment[var2.size()];

               for(int var19 = 0; var19 < var2.size(); ++var19) {
                  var18[var19] = (DocAttachment)var2.get(var19);
               }

               return var18;
            }

            var5 = Util.getIntValue(var4.getImagefileid());
         } while(var5 < 1);

         DocAttachment var6 = new DocAttachment();
         var6.setDocImageFileId(var4.getId());
         var6.setDocid(var1.getId());
         var6.setImagefileid(var5);
         var6.setImagefilename(var4.getImagefilename());
         var6.setImagefiledesc(var4.getImagefiledesc());
         var6.setImagefilewidth(var4.getimagefilewidth());
         var6.setImagefileheight(var4.getImagefileheight());
         var6.setImagefilesize(var4.getImagefielsize());
         var6.setDocfiletype(var4.getDocfiletype());
         var6.setVersionId(var4.getVersionId());
         var6.setVersionDetail(var4.getVersionDetail());
         var6.setIsextfile(var4.getIsextfile());
         byte[] var8 = new byte[1024];
         InputStream var9 = null;
         var3.getImageFileInfoById(var5);
         var9 = var3.getInputStream();
         if (var9 != null) {
            var6.setFilename(var3.getImageFileName());
            var6.setFiletype(var3.getImageFileType());
            var6.setFilerealpath(var3.getFileRealPath());
            var6.setIszip(Util.getIntValue(var3.getIsZip()));
            var6.setIsencrype(Util.getIntValue(var3.getIsencrypt()));
            var6.setIsAesEncrype(var3.getIsaesencrypt());
            var6.setAesCode(var3.getAescode());
            String var10 = "";
            ByteArrayOutputStream var11 = null;

            try {
               var11 = new ByteArrayOutputStream();

               int var7;
               while((var7 = var9.read(var8)) != -1) {
                  var11.write(var8, 0, var7);
                  var11.flush();
               }

               var10 = Base64.encode(var11.toByteArray());
            } catch (Exception var16) {
            } finally {
               if (var9 != null) {
                  var9.close();
               }

               if (var11 != null) {
                  var11.flush();
               }

               if (var11 != null) {
                  var11.close();
               }

            }

            var6.setFilecontent(var10);
         }

         var2.add(var6);
      }
   }

   private DocAttachment[] getPictures(DocInfo var1) throws Exception {
      ArrayList var2 = new ArrayList();
      DocImageManager var3 = new DocImageManager();
      var3.resetParameter();
      var3.setDocid(var1.getId());
      var3.selectDocPictures();

      while(true) {
         int var4;
         do {
            if (!var3.next()) {
               DocAttachment[] var38 = new DocAttachment[var2.size()];

               for(int var39 = 0; var39 < var2.size(); ++var39) {
                  var38[var39] = (DocAttachment)var2.get(var39);
               }

               return var38;
            }

            var4 = Util.getIntValue(var3.getImagefileid());
         } while(var4 < 1);

         DocAttachment var5 = new DocAttachment();
         var5.setDocImageFileId(var3.getId());
         var5.setDocid(var1.getId());
         var5.setImagefileid(var4);
         var5.setImagefilename(var3.getImagefilename());
         var5.setImagefiledesc(var3.getImagefiledesc());
         var5.setImagefilewidth(var3.getimagefilewidth());
         var5.setImagefileheight(var3.getImagefileheight());
         var5.setImagefilesize(var3.getImagefielsize());
         var5.setDocfiletype(var3.getDocfiletype());
         var5.setVersionId(var3.getVersionId());
         var5.setVersionDetail(var3.getVersionDetail());
         var5.setIsextfile(var3.getIsextfile());
         byte[] var7 = new byte[1024];
         BufferedInputStream var8 = null;
         ConnStatement var9 = new ConnStatement();

         try {
            String var10 = "select imagefilename,filerealpath,iszip,isencrypt,imagefiletype,imagefile,isaesencrypt,aescode from ImageFile where imagefileid = " + var4;
            boolean var11 = var9.getDBType().equals("oracle");
            var9.setStatementSql(var10);
            var9.executeQuery();
            if (var9.next()) {
               String var12 = Util.null2String(var9.getString("isaesencrypt"));
               String var13 = Util.null2String(var9.getString("aescode"));
               var5.setFilename(Util.null2String(var9.getString("imagefilename")));
               var5.setFiletype(Util.null2String(var9.getString("imagefiletype")));
               var5.setFilerealpath(Util.null2String(var9.getString("filerealpath")));
               var5.setIszip(Util.getIntValue(Util.null2String(var9.getString("iszip"))));
               var5.setIsencrype(Util.getIntValue(Util.null2String(var9.getString("isencrypt"))));
               var5.setIsAesEncrype(Util.getIntValue(var12, 0));
               var5.setAesCode(var13);
               Object var14 = null;
               if (var5.getFilerealpath().equals("")) {
                  if (var11) {
                     var8 = new BufferedInputStream(var9.getBlobBinary("imagefile"));
                  } else {
                     var8 = new BufferedInputStream(var9.getBinaryStream("imagefile"));
                  }
               } else {
                  File var15 = new File(var5.getFilerealpath());
                  var8 = new BufferedInputStream(new FileInputStream(var15));
               }

               String var40 = "";
               ByteArrayOutputStream var16 = null;

               try {
                  var16 = new ByteArrayOutputStream();

                  int var6;
                  while((var6 = var8.read(var7)) != -1) {
                     var16.write(var7, 0, var6);
                     var16.flush();
                  }

                  var40 = Base64.encode(var16.toByteArray());
               } catch (Exception var34) {
               } finally {
                  if (var8 != null) {
                     var8.close();
                  }

                  if (var14 != null) {
                     ((ZipInputStream)var14).close();
                  }

                  if (var16 != null) {
                     var16.flush();
                  }

                  if (var16 != null) {
                     var16.close();
                  }

               }

               var5.setFilecontent(var40);
            }

            var2.add(var5);
         } catch (Exception var36) {
         } finally {
            try {
               var9.close();
            } catch (Exception var33) {
            }

         }
      }
   }

   private Map getExtDocInfo(DocInfo var1) throws Exception {
      HashMap var2 = new HashMap();
      RecordSet var3 = new RecordSet();
      String var4 = "";
      var4 = "select * from DocImageFile where docid=" + var1.getId() + " and (isextfile <> '1' or isextfile is null) order by versionId desc";
      var3.executeSql(var4);
      var3.next();
      int var5 = Util.getIntValue(var3.getString("versionId"), 0);
      int var6 = Util.getIntValue(var3.getString("imagefileid"));
      if (var5 == 0) {
         var3.executeSql("select * from DocImageFile where docid=" + var1.getId() + " order by versionId desc");
         if (var3.next()) {
            var5 = Util.getIntValue(var3.getString("versionId"), 0);
            var6 = Util.getIntValue(var3.getString("imagefileid"));
         }
      }

      var2.put("versionId", var5 + "");
      var2.put("imageFileId", var6 + "");
      return var2;
   }

   private DocCustomField[] getCustomFieldInfo(DocInfo var1, User var2) throws Exception {
      ResourceConditionManager var3 = new ResourceConditionManager();
      BrowserComInfo var4 = new BrowserComInfo();
      DepartmentComInfo var5 = new DepartmentComInfo();
      RecordSet var6 = new RecordSet();
      ArrayList var7 = new ArrayList();
      CustomFieldManager var8 = new CustomFieldManager("DocCustomFieldBySecCategory", var1.getSeccategory());
      var8.getCustomFields();
      var8.getCustomData(var1.getId());

      while(var8.next()) {
         DocCustomField var9 = new DocCustomField();
         var9.setFieldid(var8.getId());
         var9.setFieldhtmltype(var8.getHtmlType());
         var9.setFielddbtype(var8.getFieldDbType());
         var9.setFieldtype(var8.getType());
         String var10 = var8.getData("field" + var8.getId());
         var10 = Util.StringReplace(var10, "\n", "<br>");
         var10 = Util.StringReplace(var10, "\r", "");
         var9.setFieldvalue(var10);
         String var11 = "";
         if (!var8.getHtmlType().equals("1") && !var8.getHtmlType().equals("2")) {
            if (!var8.getHtmlType().equals("3")) {
               if (var8.getHtmlType().equals("4")) {
                  var11 = var10;
               } else if (var8.getHtmlType().equals("5")) {
                  var8.getSelectItem(var8.getId());

                  while(var8.nextSelect()) {
                     if (var8.getSelectValue().equals(var10)) {
                        var11 = var8.getSelectName();
                        break;
                     }
                  }
               }
            } else {
               String var12 = String.valueOf(var8.getType());
               String var13 = var4.getLinkurl(var12);
               String var14 = "";
               String var15 = "";
               if (var12.equals("152") || var12.equals("16")) {
                  var13 = "/workflow/request/ViewRequest.jsp?requestid=";
               }

               if (!var12.equals("2") && !var12.equals("19")) {
                  if (var12.equals("141")) {
                     var14 = var3.getFormShowName(var10, var2.getLanguage());
                  } else if (var12.equals("4")) {
                     var14 = var5.getDepartmentname(var10);
                  } else if (!var10.equals("")) {
                     String var16 = var4.getBrowsertablename(var12);
                     String var17 = var4.getBrowsercolumname(var12);
                     String var18 = var4.getBrowserkeycolumname(var12);
                     String var19 = "";
                     HashMap var20 = new HashMap();
                     String var21;
                     if (!var12.equals("17") && !var12.equals("18") && !var12.equals("27") && !var12.equals("37") && !var12.equals("56") && !var12.equals("57") && !var12.equals("65") && !var12.equals("142") && !var12.equals("152") && !var12.equals("168")) {
                        if (var12.equals("143")) {
                           var21 = "0";
                           boolean var22 = false;
                           boolean var23 = false;
                           byte var26;
                           if (var10.startsWith(",")) {
                              var26 = 1;
                           } else {
                              var26 = 0;
                           }

                           int var29;
                           if (var10.endsWith(",")) {
                              var29 = var10.length() - 1;
                           } else {
                              var29 = var10.length();
                           }

                           if (var10.equals(",")) {
                              var21 = "0";
                           } else {
                              var21 = var10.substring(var26, var29);
                           }

                           var19 = "select " + var18 + "," + var17 + " from " + var16 + " where " + var18 + " in( " + var21 + ")";
                        } else {
                           var19 = "select " + var18 + "," + var17 + " from " + var16 + " where " + var18 + "=" + var10;
                        }
                     } else {
                        var19 = "select " + var18 + "," + var17 + " from " + var16 + " where " + var18 + " in( " + var10 + ")";
                     }

                     var6.executeSql(var19);

                     while(var6.next()) {
                        var15 = Util.null2String(var6.getString(1));
                        var21 = Util.toScreen(var6.getString(2), var2.getLanguage());
                        if (!var13.equals("")) {
                           var20.put(String.valueOf(var15), var21);
                        } else {
                           var20.put(String.valueOf(var15), var21);
                        }
                     }

                     StringTokenizer var27 = new StringTokenizer(var10, ",");
                     String var28 = "";

                     while(var27.hasMoreTokens()) {
                        var28 = var27.nextToken();
                        if (var28.length() > 0 && var20.get(var28) != null) {
                           var14 = var14 + var20.get(var28);
                        }
                     }
                  }
               } else {
                  var14 = var10;
               }

               var11 = Util.toScreen(var14, var2.getLanguage());
            }
         } else {
            var11 = var10;
         }

         var9.setFieldshow(var11);
         var7.add(var9);
      }

      DocCustomField[] var24 = new DocCustomField[var7.size()];

      for(int var25 = 0; var25 < var7.size(); ++var25) {
         var24[var25] = (DocCustomField)var7.get(var25);
      }

      return var24;
   }

   private Map getDummy(DocInfo var1) throws Exception {
      HashMap var2 = new HashMap();
      DocTreeDocFieldComInfo var3 = new DocTreeDocFieldComInfo();
      RecordSet var4 = new RecordSet();
      String var5 = "select catelogid from DocDummyDetail where docid=" + var1.getId();
      var4.executeSql(var5);
      ArrayList var6 = new ArrayList();
      ArrayList var7 = new ArrayList();

      while(var4.next()) {
         int var8 = Util.getIntValue(Util.null2String(var4.getString(1)));
         if (var8 > 0) {
            var6.add(var8 + "");
            var7.add(Util.null2String(var3.getTreeDocFieldName(var8 + "")));
         }
      }

      int[] var11 = new int[var6.size()];

      for(int var9 = 0; var9 < var6.size(); ++var9) {
         var11[var9] = Util.getIntValue((String)var6.get(var9));
      }

      String[] var12 = new String[var7.size()];

      for(int var10 = 0; var10 < var7.size(); ++var10) {
         var12[var10] = (String)var7.get(var10);
      }

      var2.put("dummyIds", var11);
      var2.put("dummyNames", var12);
      return var2;
   }

   private Map getChildDocInfo(DocInfo var1) throws Exception {
      ArrayList var2 = new ArrayList();
      ArrayList var3 = new ArrayList();
      RecordSet var4 = new RecordSet();
      boolean var5 = true;
      String var6 = "";
      int var10;
      if (var1.getDocEditionId() > -1) {
         var4.executeSql(" select id,docSubject from DocDetail where doceditionid = " + var1.getDocEditionId() + " and doceditionid > 0  and (isHistory<>'1' or isHistory is null or isHistory='') order by docedition desc ");
         var4.next();
         var10 = Util.getIntValue(var4.getString("id"));
         var6 = Util.null2String(var4.getString("docSubject"));
      } else {
         var10 = var1.getId();
         var6 = var1.getDocSubject();
      }

      if (var10 > 0) {
         var2.add(var10 + "");
         var3.add(var6);
         boolean var7 = true;
         String var8 = "";
         var4.executeSql(" select id,docSubject from DocDetail where id <> " + var10 + " and mainDoc = " + var10 + " and (isHistory<>'1' or isHistory is null or isHistory='') order by id asc ");

         while(var4.next()) {
            int var11 = Util.getIntValue(var4.getString("id"));
            var8 = Util.null2String(var4.getString("docSubject"));
            if (var11 > 0) {
               var2.add(var11 + "");
               var3.add(var8);
            }
         }
      }

      int[] var12 = new int[var2.size()];

      for(int var13 = 0; var13 < var2.size(); ++var13) {
         var12[var13] = Util.getIntValue((String)var2.get(var13));
      }

      String[] var14 = new String[var3.size()];

      for(int var9 = 0; var9 < var3.size(); ++var9) {
         var14[var9] = (String)var3.get(var9);
      }

      HashMap var15 = new HashMap();
      var15.put("childdocids", var12);
      var15.put("chiledocnames", var14);
      return var15;
   }

   private int getUserId(String var1) {
      try {
         String var2 = "select id from HrmResource where loginid='" + var1 + "' union select id from HrmResourcemanager where loginid='" + var1 + "'";
         RecordSet var3 = new RecordSet();
         var3.executeSql(var2);
         if (var3.next() && Util.getIntValue(var3.getString(1), 0) > 0) {
            return Util.getIntValue(var3.getString(1));
         }
      } catch (Exception var4) {
         var4.printStackTrace();
      }

      return 0;
   }

   private int getUserId(String var1, int var2) {
      int var3 = 0;
      if (var2 == 2) {
         try {
            String var4 = "select id from HrmResource where loginid='" + var1 + "' ";
            RecordSet var5 = new RecordSet();
            var5.executeSql(var4);
            if (var5.next() && Util.getIntValue(var5.getString(1), 0) > 0) {
               var3 = Util.getIntValue(var5.getString(1));
            }
         } catch (Exception var6) {
            var6.printStackTrace();
         }
      } else {
         var3 = this.getUserId(var1);
      }

      return var3;
   }

   private User getUserById(int var1) {
      RecordSet var2 = new RecordSet();
      User var3 = null;
      String var4 = "select * from HrmResource where id=" + var1 + "";
      var2.executeSql(var4);
      if (var2.next()) {
         var3 = new User();
         var3.setUid(var2.getInt("id"));
         var3.setLoginid("loginid");
         var3.setFirstname(var2.getString("firstname"));
         var3.setLastname(var2.getString("lastname"));
         var3.setAliasname(var2.getString("aliasname"));
         var3.setTitle(var2.getString("title"));
         var3.setTitlelocation(var2.getString("titlelocation"));
         var3.setSex(var2.getString("sex"));
         String var5 = var2.getString("systemlanguage");
         var3.setLanguage(Util.getIntValue(var5, 7));
         var3.setTelephone(var2.getString("telephone"));
         var3.setMobile(var2.getString("mobile"));
         var3.setMobilecall(var2.getString("mobilecall"));
         var3.setEmail(var2.getString("email"));
         var3.setCountryid(var2.getString("countryid"));
         var3.setLocationid(var2.getString("locationid"));
         var3.setResourcetype(var2.getString("resourcetype"));
         var3.setContractdate(var2.getString("contractdate"));
         var3.setJobtitle(var2.getString("jobtitle"));
         var3.setJobgroup(var2.getString("jobgroup"));
         var3.setJobactivity(var2.getString("jobactivity"));
         var3.setJoblevel(var2.getString("joblevel"));
         var3.setSeclevel(var2.getString("seclevel"));
         var3.setUserDepartment(Util.getIntValue(var2.getString("departmentid"), 0));
         var3.setUserSubCompany1(Util.getIntValue(var2.getString("subcompanyid1"), 0));
         var3.setUserSubCompany2(Util.getIntValue(var2.getString("subcompanyid2"), 0));
         var3.setUserSubCompany3(Util.getIntValue(var2.getString("subcompanyid3"), 0));
         var3.setUserSubCompany4(Util.getIntValue(var2.getString("subcompanyid4"), 0));
         var3.setManagerid(var2.getString("managerid"));
         var3.setAssistantid(var2.getString("assistantid"));
         var3.setPurchaselimit(var2.getString("purchaselimit"));
         var3.setCurrencyid(var2.getString("currencyid"));
         var3.setLogintype("1");
         var3.setAccount(var2.getString("account"));
      }

      var2.executeSql(" SELECT id,loginid,firstname,lastname,systemlanguage,seclevel FROM HrmResourceManager WHERE id=" + var1);
      if (var2.next()) {
         var3 = new User();
         var3.setUid(var1);
         var3.setLoginid(var2.getString("loginid"));
         var3.setFirstname(var2.getString("firstname"));
         var3.setLastname(var2.getString("lastname"));
         var3.setLanguage(Util.getIntValue(var2.getString("systemlanguage"), 0));
         var3.setSeclevel(var2.getString("seclevel"));
         var3.setLogintype("1");
      }

      return var3;
   }

   private int checkLogin(String var1, String var2, int var3) {
      if (var1 != null && !"".equals(var1)) {
         if (var3 == 1) {
            return this.verifyLoginByDyna(var1, var2);
         } else {
            return var3 == 2 ? this.verifyLoginByLdap(var1, var2) : this.verifyLoginByDb(var1, var2);
         }
      } else {
         return 0;
      }
   }

   private int verifyLoginByDyna(String var1, String var2) {
      try {
         String var3 = "select id from HrmResource where loginid='" + var1 + "' union select id from HrmResourcemanager where loginid='" + var1 + "'";
         String var4 = "0";
         String var5 = "";
         RecordSet var6 = new RecordSet();
         var6.executeSql(var3);
         if (var6.next() && Util.getIntValue(var6.getString(1), 0) > 0) {
            var4 = var6.getString(1);
            Class var7 = Class.forName("weaver.hrm.resource.UserSecComInfo");
            Object var8 = var7.newInstance();
            Class[] var9 = new Class[]{Class.forName("java.lang.String")};
            Method var10 = var7.getMethod("getUserSecInfoLoginId", var9);
            String var11 = (String)var10.invoke(var8, var4);
            Method var12 = var7.getMethod("getUserSecInfoPassword", var9);
            String var13 = (String)var12.invoke(var8, var4);
            if (var11 != null && var11.equalsIgnoreCase(var1)) {
               return var13.equals(Util.getEncrypt(var2)) ? 1 : 2;
            } else {
               return 3;
            }
         } else {
            return 4;
         }
      } catch (Exception var14) {
         var14.printStackTrace();
         return 5;
      }
   }

   private int verifyLoginByLdap(String var1, String var2) {
      boolean var3 = false;

      int var11;
      try {
         RecordSet var4 = new RecordSet();
         String var5 = Prop.getPropValue(GCONST.getConfigFile(), "authentic");
         boolean var6 = true;
         if (var5 != null && var5.equals("ldap")) {
            var4.executeSql("select * from HrmResourceManager where loginid = '" + var1 + "'");
            if (var4.next()) {
               var6 = false;
            }
         }

         String var7 = "";
         var4.executeSql("select isADAccount from HrmResource where loginid='" + var1 + "'");
         if (var4.next()) {
            var7 = var4.getString("isADAccount");
         }

         if (this.ifEqlTarget(var5, "ldap") && this.ifEqlTarget(var7, "1") && var6) {
            LdapUtil var8 = LdapUtil.getInstance();
            boolean var9 = var8.authentic(var1, var2);
            if (var9) {
               var11 = 1;
            } else {
               var11 = 2;
            }
         } else {
            var11 = this.verifyLoginByDb(var1, var2);
         }
      } catch (Exception var10) {
         var10.printStackTrace();
         var11 = 5;
      }

      this.writeLog("verifyLoginByLdap: result = " + var11);
      return var11;
   }

   private int verifyLoginByDb(String var1, String var2) {
      try {
         RecordSet var3 = new RecordSet();
         String var4 = "select id,password from HrmResource where loginid='" + var1 + "' union select id,password from HrmResourcemanager where loginid='" + var1 + "'";
         String var5 = "";
         var3.executeSql(var4);
         if (var3.next() && Util.getIntValue(var3.getString(1), 0) > 0) {
            var5 = Util.null2String(var3.getString(2));
            return var5.equals(Util.getEncrypt(var2)) ? 1 : 2;
         } else {
            return 3;
         }
      } catch (Exception var6) {
         var6.printStackTrace();
         return 5;
      }
   }

   public String addDocShareByUser(DocShareInfo[] var1, User var2) throws Exception {
      String var3 = "";
      if (var2 == null) {
         var3 = "-2";
         return var3;
      } else if (var1.length <= 0) {
         var3 = "-3";
         return var3;
      } else {
         ArrayList var4 = new ArrayList();
         DocShareInfo var5 = null;
         boolean var6 = false;
         boolean var7 = false;
         boolean var8 = false;
         boolean var9 = false;
         boolean var10 = false;
         boolean var11 = false;
         boolean var12 = false;
         boolean var13 = false;
         boolean var14 = false;
         boolean var15 = false;
         boolean var16 = false;
         boolean var17 = false;
         String var18 = null;
         boolean var19 = false;
         boolean var20 = false;
         RecordSet var21 = new RecordSet();
         String var22 = "";
         char var23 = 2;
         String var24 = "" + var2.getUID();
         String var25 = var2.getLogintype();
         String var26 = var2.getSeclevel();
         String var27 = "" + var2.getType();
         String var28 = "" + var2.getUserDepartment();
         String var29 = "" + var2.getUserSubCompany1();
         String var30 = var25 + "_" + var24 + "_" + var26 + "_" + var27 + "_" + var28 + "_" + var29;
         Object var31 = null;
         SpopForDoc var32 = new SpopForDoc();
         boolean var33 = false;
         boolean var34 = false;
         HashMap var35 = new HashMap();

         int var38;
         for(int var36 = 0; var36 < var1.length; ++var36) {
            var5 = var1[var36];
            var38 = Util.getIntValue(var5.getDocId(), 0);
            if (var38 > 0) {
               if ((List)var35.get("" + var38) != null) {
                  var31 = (List)var35.get("" + var38);
               } else {
                  var31 = var32.getDocOpratePopedom("" + var38, var30);
                  var35.put("" + var38, var31);
               }

               var33 = false;
               var34 = false;
               if (((String)((List)var31).get(0)).equals("true")) {
                  var33 = true;
               }

               if (((String)((List)var31).get(3)).equals("true")) {
                  var34 = true;
               }

               int var42 = Util.getIntValue(var5.getShareLevel(), 0);
               if (var34 || var33 && var42 == 1) {
                  int var39 = Util.getIntValue(var5.getShareType(), 0);
                  int var40 = Util.getIntValue(var5.getSecLevel(), 0);
                  int var41 = Util.getIntValue(var5.getRoleLevel(), 0);
                  int var43 = Util.getIntValue(var5.getUserId(), 0);
                  int var44 = Util.getIntValue(var5.getSubCompanyId(), 0);
                  int var45 = Util.getIntValue(var5.getDepartmentId(), 0);
                  int var46 = Util.getIntValue(var5.getRoleId(), 0);
                  int var47 = Util.getIntValue(var5.getForAllUser(), 0);
                  int var48 = Util.getIntValue(var5.getCrmId(), 0);
                  int var49 = Util.getIntValue(var5.getShareSource(), 0);
                  var18 = Util.null2String(var5.getIsSecDefaultShare());
                  int var50 = Util.getIntValue(var5.getOrgGroupId(), 0);
                  int var51 = Util.getIntValue(var5.getDownloadLevel(), 0);
                  var22 = "" + var38;
                  var22 = var22 + "" + var23 + var39;
                  var22 = var22 + "" + var23 + var40;
                  var22 = var22 + "" + var23 + var41;
                  var22 = var22 + "" + var23 + var42;
                  var22 = var22 + "" + var23 + var43;
                  var22 = var22 + "" + var23 + var44;
                  var22 = var22 + "" + var23 + var45;
                  var22 = var22 + "" + var23 + var46;
                  var22 = var22 + "" + var23 + var47;
                  var22 = var22 + "" + var23 + var48;
                  var22 = var22 + "" + var23 + var50;
                  var22 = var22 + "" + var23 + var51;
                  var21.executeProc("DocShare_IFromDocSecCat_G", var22);
                  if (var4.indexOf("" + var38) == -1) {
                     var4.add("" + var38);
                     if (var3.equals("")) {
                        var3 = "" + var38;
                     } else {
                        var3 = var3 + "," + var38;
                     }
                  }
               }
            }
         }

         DocViewer var52 = new DocViewer();

         for(int var37 = 0; var37 < var4.size(); ++var37) {
            var38 = Util.getIntValue((String)var4.get(var37), 0);
            var52.setDocShareByDoc("" + var38);
         }

         return var3;
      }
   }

   public boolean ifEqlTarget(String var1, String var2) {
      if (var1 != null && !var1.equals("")) {
         return var1.equals(var2);
      } else {
         return false;
      }
   }
}
